
type t

val add_type : Eff.item_key -> Eff.type_ -> t -> t 
val add_const : Eff.item_key -> Eff.const -> t -> t 
val add_node : Eff.node_key -> Eff.node_exp -> t -> t

val empty : t

(* fold : (key -> 'a -> 'b -> 'b) -> 'a t -> 'b -> 'b *)

val fold_consts : (Eff.item_key -> Eff.const -> 'a -> 'a) -> t -> 'a -> 'a
val fold_types  : (Eff.item_key -> Eff.type_ -> 'a -> 'a) -> t -> 'a -> 'a
val fold_nodes  : (Eff.node_key -> Eff.node_exp -> 'a -> 'a) -> t -> 'a -> 'a

val iter_consts : (Eff.item_key -> Eff.const -> unit) -> t -> unit
val iter_types  : (Eff.item_key -> Eff.type_ -> unit) -> t -> unit 
val iter_nodes  : (Eff.node_key -> Eff.node_exp -> unit) -> t -> unit

val to_file : out_channel -> t -> unit

val find_type  : t -> Eff.item_key -> Eff.type_
val find_const : t -> Eff.item_key -> Eff.const
val find_node  : t -> Eff.node_key -> Eff.node_exp

val fresh_type_id : t -> Ident.pack_name -> string -> Ident.long
